
-- 99.9% of the code stolen from Micah's ColorBlind AddOn. <3

local Original_ContainerFrameItemButton_OnEnter;
local Original_GameTooltip_SetLootItem;
local Original_AuctionFrameItem_OnEnter;
local Original_PaperDollItemSlotButton_OnEnter;

function Tooltip_Rarity_OnLoad()
	Original_ContainerFrameItemButton_OnEnter = ContainerFrameItemButton_OnEnter;
	ContainerFrameItemButton_OnEnter = TTR_ContainerFrameItemButton_OnEnter;

	Original_GameTooltip_SetLootItem = GameTooltip.SetLootItem;
	GameTooltip.SetLootItem = TTR_GameTooltip_SetLootItem;

	Original_AuctionFrameItem_OnEnter = AuctionFrameItem_OnEnter;
	AuctionFrameItem_OnEnter = TTR_AuctionFrameItem_OnEnter;

	Original_PaperDollItemSlotButton_OnEnter = PaperDollItemSlotButton_OnEnter;
	PaperDollItemSlotButton_OnEnter = TTR_PaperDollItemSlotButton_OnEnter;
end

function TTR_ContainerFrameItemButton_OnEnter()
	Original_ContainerFrameItemButton_OnEnter();
	local frameID = this:GetParent():GetID();
	local buttonID = this:GetID();
	local texture, itemCount, locked, quality, readable = GetContainerItemInfo(frameID, buttonID);
	if(quality) then
		local rarity = getglobal("ITEM_QUALITY".. quality .."_DESC");
		GameTooltip:AddLine(TEXT(rarity), "", 1, 1, 1);
		GameTooltip:Show();
	end	
end

function TTR_GameTooltip_SetLootItem(this, slot)
	Original_GameTooltip_SetLootItem(this, slot);
	local texture, item, quantity, quality = GetLootSlotInfo(slot);
	if(quality) then
		local rarity = getglobal("ITEM_QUALITY".. quality .."_DESC");
		GameTooltip:AddLine(TEXT(rarity), "", 1, 1, 1);
		GameTooltip:Show();
	end
end

function TTR_AuctionFrameItem_OnEnter(type, index)
	Original_AuctionFrameItem_OnEnter(type, index);
	local texture, itemCount, locked, quality, readable = GetAuctionItemInfo(type, index);
	if(quality) then
		local rarity = getglobal("ITEM_QUALITY".. quality .."_DESC");
		GameTooltip:AddLine(TEXT(rarity), "", 1, 1, 1);
		GameTooltip:Show();
	end
end

function TTR_PaperDollItemSlotButton_OnEnter()
	Original_PaperDollItemSlotButton_OnEnter();
	local quality = GetInventoryItemQuality("player", this:GetID());
	if(quality) then
		local rarity = getglobal("ITEM_QUALITY".. quality .."_DESC");
		GameTooltip:AddLine(TEXT(rarity), "", 1, 1, 1);
		GameTooltip:Show();
	end
end